// © 2022 Daily, Co. All Rights Reserved
// ignore_for_file: discarded_futures

import 'package:daily_flutter/daily_flutter.dart';
import 'package:flutter/material.dart';

///////////////////////////////////////////////////////////
//
// For a much more in-depth example, see:
// https://github.com/daily-demos/daily-flutter-demo
//
///////////////////////////////////////////////////////////
void main() => runApp(const MyApp());

class MyApp extends StatefulWidget {
  const MyApp({super.key});

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  late final CallClient _callClient = CallClient();
  final _controller = VideoViewController();

  @override
  void initState() {
    super.initState();
    _callClient.updateInputs(
      inputs: const InputSettingsUpdate.set(
        camera: CameraInputSettingsUpdate.set(isEnabled: BoolUpdate.set(true)),
        microphone: MicrophoneInputSettingsUpdate.set(isEnabled: BoolUpdate.set(true)),
      ),
    );
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(title: const Text('Daily example')),
        body: Center(child: VideoView(controller: _controller)),
      ),
    );
  }
}
