// © 2022 Daily, Co. All Rights Reserved

mixin Update<T> {
  dynamic toJson();
  static Update<T> fromDefaults<T>() => const UpdateFromDefaults();
}

class UpdateFromDefaults<T> with Update<T> {
  const UpdateFromDefaults();
  static const UpdateFromDefaults<Never> instance = UpdateFromDefaults();

  @override
  dynamic toJson() => 'fromDefaults';
}

class StringUpdate with Update<String> {
  const StringUpdate.set(this.value);

  static const Update<String> fromDefaults = UpdateFromDefaults.instance;

  final String value;

  @override
  String toJson() => value;
}

class BoolUpdate with Update<bool> {
  // ignore: avoid_positional_boolean_parameters
  const BoolUpdate.set(this.value);
  static const Update<bool> fromDefaults = UpdateFromDefaults.instance;
  final bool value;

  @override
  bool toJson() => value;
}

class IntUpdate with Update<int> {
  const IntUpdate(this.value);
  static const Update<int> fromDefaults = UpdateFromDefaults.instance;
  final int value;

  @override
  int toJson() => value;
}

class DoubleUpdate with Update<double> {
  const DoubleUpdate(this.value);
  static const Update<double> fromDefaults = UpdateFromDefaults.instance;
  final double value;

  @override
  double toJson() => value;
}
